//-----------------------------------------------------------------------------
// ዾ
//-----------------------------------------------------------------------------
// MinGW(gcc)ɂăRpC܂B
// filter.h AviUtlTCg AviUtl Plugin SDK ɓĂ܂B
//-----------------------------------------------------------------------------
#include <windows.h>
#include <stdio.h>
#include "filter.h"

#define WINDOW_W 288
#define WINDOW_H 288
#define MAG_MAX  24 // ő{
#define MAG_MIN  -9 // ǩWŏ
#define RULER_SIZE 8 // [[̕

// j[ID
#define IDM_REVERSE     101
#define IDM_RULER       102
#define IDM_GRID_NONE   103
#define IDM_GRID_BLACK  104
#define IDM_GRID_WHITE  105

static HDC bufDC = NULL;
static HBITMAP bufBMP = NULL;
static int bmp_width  = 0;
static int bmp_height = 0;
static int nnn = 2;            // {i1ȏゾƂ̂܂ܔ{ŊgB0ȉł2^((nnn-1)/2){̋ߎj
static POINT pos = {16,16};    // W
static POINT sub_pos = {0,0};  // TuWi{𕪕ƂŒ菬̂悤Ȃ́j
static POINT drag_pos = {0,0}; // ÕhbOʒu

static BOOL bFixFlag = FALSE;
static BOOL bReverse = FALSE; // zC[̉]t]
static BOOL bRuler   = TRUE;  // [[̕\
static BOOL bMenu    = TRUE;  // j[̕\
static BOOL bDragFlagWin  = FALSE; // EChEŃhbO
static BOOL bDragFlagEdit = FALSE; // ҏWʏŃhbO
static int gGrid = 0; // Obh

//---------------------------------------------------------------------
// tB^\̒`
//---------------------------------------------------------------------
FILTER_DLL filter = {
    FILTER_FLAG_ALWAYS_ACTIVE|FILTER_FLAG_MAIN_MESSAGE|FILTER_FLAG_WINDOW_SIZE|FILTER_FLAG_DISP_FILTER|FILTER_FLAG_EX_INFORMATION|FILTER_FLAG_WINDOW_THICKFRAME,
    WINDOW_W,WINDOW_H,
    (TCHAR *)"ዾ",
    0,NULL,NULL,
    NULL,NULL,
    0,NULL,NULL,
    func_proc,
    NULL,
    NULL,
    NULL,
    func_WndProc,
    NULL,NULL,
    NULL,
    0,
    (TCHAR *)"ዾ r10 by ۂ",
    NULL,NULL,
    NULL,NULL,NULL,NULL,
    NULL,
};


//---------------------------------------------------------------------
// tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
    return &filter;
}

//---------------------------------------------------------------------
// YUY2tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTableYUY2( void )
{
    return &filter;
}

//---------------------------------------------------------------------
// foCXReLXgǗ
//---------------------------------------------------------------------
void mem_alloc( FILTER *fp )
{
    if( bufDC == NULL && bufBMP == NULL )
    {
        SYS_INFO si;
        fp->exfunc->get_sys_info( NULL, &si );
        HDC hdc = GetDC( fp->hwnd );
        bufDC = CreateCompatibleDC( hdc ); // :ʂ̐FƓɂȂ
        bufBMP = CreateCompatibleBitmap( hdc, si.max_w, si.max_h ); // VRAMɋ󂫂΂Ɋmۂ͂
        SelectObject( bufDC, bufBMP );
        DeleteDC( hdc );
    }
}

void mem_free( void )
{
    if( bufDC )
    {
        DeleteDC( bufDC );
        bufDC = NULL;
    }
    if( bufBMP )
    {
        DeleteObject( (HGDIOBJ)bufBMP );
        bufBMP = NULL;
    }
}

//---------------------------------------------------------------------
// k̕vZ
//---------------------------------------------------------------------
inline int nnn2ratio( int nnn )
{
    // nnn0, -1, -2, -3, -4, -5, -6, -7ccƌ邲Ƃ
    // 2/3, 2/4, 2/6, 2/8, 2/12, 2/16, 2/24, 2/32ccƂȂ鐔́ghԂ
    // ͈̐ȉ̐̋ߎ
    // 1/2, 1/2, 1/22, 1/4, 1/42, 1/8, 1/82, 1/16cc
    // ʍ
    // 2^((nnn-1)/2)

    if( nnn >= 0 ) return 3;
    int i = 1 - nnn;
    int ratio = 2 << (i >> 1);
    if( i & 0x1 ) ratio += ratio >> 1;
    return ratio;
}

//---------------------------------------------------------------------
// EChẼ^Cg
//---------------------------------------------------------------------
void setTitleStr( char *str, int nnn )
{
    const char *fixed = bFixFlag ? "[WŒ]" : " ";
    if( nnn > 0 )
    {
        sprintf( str, "ዾ - %d{ %s", nnn, fixed );
    }
    else if( nnn == 0 )
    {
        sprintf( str, "ዾ - 2/3{ %s", fixed );
    }
    else if( nnn >= MAG_MIN )
    {
        int ratio = nnn2ratio( nnn );
        sprintf( str, "ዾ - 1/%d{ %s", ratio/2, fixed );
    }
    else
    {
        sprintf( str, "ዾ - *{ %s", fixed );
    }
}

//---------------------------------------------------------------------
// \
//---------------------------------------------------------------------
void disp( FILTER *fp, void *editp, POINT *pp )
{
    HDC hdc;
    RECT rc, blank_rc;
    HRGN hRgn;
    BOOL is_editing = FALSE;

    if( fp ) is_editing = fp->exfunc->is_editing( editp );


    if( bufDC && is_editing )
    {
        hdc = GetDC( fp->hwnd );
        GetClientRect( fp->hwnd, &rc );

        if( pp )
        {
            pos.x = pp->x;
            pos.y = pp->y;
            sub_pos.x = sub_pos.y = 0;
        }

        // TuWi{𕪕ƂŒ菬̂悤Ȃ́jCWɉZ
        if( nnn > 0 )
        {
            // g厞
            pos.x -= sub_pos.x / nnn;
            pos.y -= sub_pos.y / nnn;
            sub_pos.x %= nnn;
            sub_pos.y %= nnn;
        }
        else
        {
            // k
            int ratio = nnn2ratio( nnn );
            pos.x -= sub_pos.x * ratio / 2;
            pos.y -= sub_pos.y * ratio / 2;
            sub_pos.x = 0;
            sub_pos.y = 0;
        }

        // StretchDIBitsɓnlvZ
        int center_x = (rc.right - rc.left) / 2;
        int center_y = (rc.bottom - rc.top) / 2;
        int src_width  = bmp_width;
        int src_height = bmp_height;
        int src_x = 0;
        int src_y = 0;
        int dst_x, dst_y, dst_width, dst_height;
        if( nnn > 0 )
        {
            // g厞
            dst_x = rc.left - pos.x * nnn + center_x + sub_pos.x;
            dst_y = rc.top  - pos.y * nnn + center_y + sub_pos.y;
            dst_width  = src_width  * nnn;
            dst_height = src_height * nnn;
        }
        else
        {
            // k
            int ratio = nnn2ratio( nnn );;
            dst_x = rc.left - pos.x * 2 / ratio + center_x;
            dst_y = rc.top  - pos.y * 2 / ratio + center_y;
            dst_width  = src_width  * 2 / ratio;
            dst_height = src_height * 2 / ratio;
        }

        // EChEO̔\GcȃNbsO
        // ȂĂǂ኱
        // k̓EChEOւ͂ݏo邱ƂȂ̂łȂƂɂ
        if( nnn > 0 )
        {
            if( dst_x < rc.left )
            {
                int d     = rc.left - dst_x;
                int d_dst = d - d % nnn;
                int d_src = d / nnn;
                dst_x     += d_dst;
                dst_width -= d_dst;
                src_x     += d_src;
                src_width -= d_src;
            } 
            if( dst_x + dst_width > rc.right )
            {
                int d = (dst_x + dst_width) - rc.right;
                int d_dst = d - d % nnn;
                int d_src = d / nnn;
                dst_width -= d_dst;
                src_width -= d_src;
            }
            if( dst_y < rc.top )
            {
                int d = rc.top - dst_y;
                int d_dst = d - d % nnn;
                int d_src = d / nnn;
                dst_y      += d_dst;
                dst_height -= d_dst;
                src_y      += d_src;
                src_height -= d_src;
            }
            if( dst_y + dst_height > rc.bottom )
            {
                int d = (dst_y + dst_height) - rc.bottom;
                int d_dst = d - d % nnn;
                int d_src = d / nnn;
                dst_height -= d_dst;
                src_height -= d_src;
            }
        }

        // [[iڐj
        if( bRuler && nnn >= 2 )
        {
            HPEN hPen = (HPEN)GetStockObject( BLACK_PEN ); // y
            HPEN hOldPen = (HPEN)SelectObject( hdc, hPen );
            // ܂[[wi𔒂œhԂ
            HBRUSH hBG = (HBRUSH)GetStockObject( WHITE_BRUSH );
            blank_rc.left   = rc.left;
            blank_rc.right  = rc.right;
            blank_rc.top    = rc.top;
            blank_rc.bottom = rc.top + RULER_SIZE;
            FillRect( hdc, &blank_rc, hBG );
            blank_rc.left   = rc.left;
            blank_rc.right  = rc.left + RULER_SIZE;
            blank_rc.top    = rc.top;
            blank_rc.bottom = rc.bottom;
            FillRect( hdc, &blank_rc, hBG );
            // Ɖɕ\
            for( int sx = 0; sx <= src_width; sx++ )
            {
                int dx = dst_x + sx * nnn;
                if( dx >= RULER_SIZE )
                {
                    int h = ( (src_x + sx) % 10 == 0 ) ? RULER_SIZE : (RULER_SIZE + 2) / 3;
                    MoveToEx( hdc, dx, 0, NULL );
                    LineTo( hdc, dx, h );
                }
            }
            // cƉEɕ\
            for( int sy = 0; sy <= src_height; sy++ )
            {
                int dy = dst_y + sy * nnn;
                if( dy >= RULER_SIZE )
                {
                    int h = ( (src_y + sy) % 10 == 0 ) ? RULER_SIZE : (RULER_SIZE + 2) / 3;
                    MoveToEx( hdc, 0, dy, NULL );
                    LineTo( hdc, h,  dy );
                }
            }
            SelectObject( hdc, hOldPen ); // y߂
        }

        // [[Ȃ悤ɃNbsOݒ
        if( bRuler && nnn >= 2 )
        {
            hRgn = CreateRectRgn( rc.left + RULER_SIZE, rc.top + RULER_SIZE, rc.right, rc.bottom );
            SelectClipRgn( hdc , hRgn );
        }

        // ɗ]ȂhԂ
        if( dst_x > rc.left )
        {
            blank_rc.left   = rc.left;
            blank_rc.right  = dst_x;
            blank_rc.top    = rc.top;
            blank_rc.bottom = rc.bottom;
            FillRect(hdc, &blank_rc, (HBRUSH)(COLOR_ACTIVEBORDER+1));
        }
        // ɗ]ȂhԂ
        if( dst_y > rc.top )
        {
            blank_rc.left   = rc.left;
            blank_rc.right  = rc.right;
            blank_rc.top    = rc.top;
            blank_rc.bottom = dst_y;
            FillRect(hdc, &blank_rc, (HBRUSH)(COLOR_ACTIVEBORDER+1));
        }
        // Eɗ]ȂhԂ
        if( dst_x + dst_width < rc.right )
        {
            blank_rc.left   = dst_x + dst_width;
            blank_rc.right  = rc.right;
            blank_rc.top    = rc.top;
            blank_rc.bottom = rc.bottom;
            FillRect(hdc, &blank_rc, (HBRUSH)(COLOR_ACTIVEBORDER+1));
        }
        // ɗ]ȂhԂ
        if( dst_y + dst_height < rc.bottom )
        {
            blank_rc.left   = rc.left;
            blank_rc.right  = rc.right;
            blank_rc.top    = dst_y + dst_height;
            blank_rc.bottom = rc.bottom;
            FillRect(hdc, &blank_rc, (HBRUSH)(COLOR_ACTIVEBORDER+1));
        }

        // [StretchBltŊg]
        // StretchBlt͑Ŝg又Ă]Ă炵B
        // \g又邽߁A̕Ԃ|Ă܂B
        // őOiKőGcɃNbsO邱ƂőxAbvĂB
        if( src_width > 0 && src_height > 0 )
        {
            SetStretchBltMode( hdc, COLORONCOLOR );
            StretchBlt(
                hdc, dst_x, dst_y, dst_width, dst_height,
                bufDC, src_x, src_y, src_width, src_height,
                SRCCOPY );
        }

        // Obh`
        if( gGrid >= 1 && nnn >= 2 )
        {
            HPEN hPen = (HPEN)GetStockObject( (gGrid==1)?BLACK_PEN:WHITE_PEN ); // y
            HPEN hOldPen = (HPEN)SelectObject( hdc, hPen );
            // c
            for( int sx = 0; sx < src_width; sx++ )
            {
                int dx = dst_x + sx * nnn;
                MoveToEx( hdc, dx, 0, NULL );
                LineTo( hdc, dx, rc.bottom );
            }
            // 
            for( int sy = 0; sy < src_height; sy++ )
            {
                int dy = dst_y + sy * nnn;
                MoveToEx( hdc, 0, dy, NULL );
                LineTo( hdc, rc.right, dy );
            }
            SelectObject( hdc, hOldPen ); // y߂
        }

        ReleaseDC( fp->hwnd, hdc );
        if( bRuler && nnn >= 2 ) DeleteObject( hRgn );
    }
    else
    {
        hdc = GetDC( fp->hwnd );
        GetClientRect( fp->hwnd, &rc );
        FillRect( hdc, &rc, (HBRUSH)(COLOR_ACTIVEBORDER + 1) );
        ReleaseDC( fp->hwnd, hdc );
    }
}

//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp, FILTER_PROC_INFO *fpip )
{
    void *editp = fpip->editp;
    BOOL is_editing = fp->exfunc->is_editing( editp );

    if( bufDC && is_editing )
    {
        int w = fpip->w;
        int h = fpip->h;

        bmp_width  = w;
        bmp_height = h;

        // rbg}bṽwb_쐬
        BITMAPINFO bmi;
        ZeroMemory( &bmi, sizeof(bmi) );
        bmi.bmiHeader.biSize        = sizeof(bmi.bmiHeader);
        bmi.bmiHeader.biWidth       = w;
        bmi.bmiHeader.biHeight      = h;
        bmi.bmiHeader.biPlanes      = 1;
        bmi.bmiHeader.biBitCount    = 24;
        bmi.bmiHeader.biCompression = BI_RGB;
        bmi.bmiHeader.biPlanes      = 1;

        // rbg}bvbufDCɃRs[
        void *pixelp = fp->exfunc->get_disp_pixelp( editp, NULL );
        SetDIBitsToDevice(
            bufDC,
            0, 0, w, h,
            0, 0, 0, h,
            pixelp, &bmi, DIB_RGB_COLORS );

        disp( fp, editp, NULL ); // \
    }

    return TRUE;
}

//---------------------------------------------------------------------
// WndProc
//---------------------------------------------------------------------
BOOL func_WndProc( HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam, void *editp, FILTER *fp )
{
    char title[1024] = "ዾ";

    switch( message )
    {
        case WM_FILTER_INIT:
            // INIݒǂݍ
            bReverse = !!fp->exfunc->ini_load_int( fp, (LPSTR)"reverse", 0 ); // o[X[h
            nnn      =   fp->exfunc->ini_load_int( fp, (LPSTR)"nnn", nnn );   // O̔{
            bRuler   = !!fp->exfunc->ini_load_int( fp, (LPSTR)"ruler", 1 );   // [[\̗L
            bMenu    = !!fp->exfunc->ini_load_int( fp, (LPSTR)"menu", 1  );   // j[\̗L
            gGrid    =   fp->exfunc->ini_load_int( fp, (LPSTR)"grid", 0 );    // Obh
            if( nnn < MAG_MIN ) nnn = MAG_MIN;
            if( nnn > MAG_MAX ) nnn = MAG_MAX;

            // j[쐬
            if( bMenu )
            {
                HMENU hmenu = CreateMenu();
                HMENU hsubm = CreateMenu();
                MENUITEMINFO menuInfo;
                menuInfo.cbSize = sizeof(MENUITEMINFO);

                menuInfo.fMask = MIIM_TYPE | MIIM_SUBMENU;;
                menuInfo.fType = MFT_STRING;
                menuInfo.hSubMenu = hsubm;
                menuInfo.dwTypeData = (LPSTR)"ݒ";
                InsertMenuItem( hmenu, 0, TRUE, &menuInfo );

                menuInfo.fMask = MIIM_TYPE | MIIM_STATE | MIIM_ID;

                menuInfo.dwTypeData = (LPSTR)"zC[]";
                menuInfo.wID = IDM_REVERSE;
                menuInfo.fState = bReverse ? MFS_CHECKED : MFS_UNCHECKED;
                InsertMenuItem( hsubm, 0, TRUE, &menuInfo );

                menuInfo.dwTypeData = (LPSTR)"[[";
                menuInfo.wID = IDM_RULER;
                menuInfo.fState = bRuler ? MFS_CHECKED : MFS_UNCHECKED;
                InsertMenuItem( hsubm, 1, TRUE, &menuInfo );

                menuInfo.dwTypeData = (LPSTR)"Obh(Ȃ)";
                menuInfo.wID = IDM_GRID_NONE;
                menuInfo.fState = (gGrid == 0) ? MFS_CHECKED : MFS_UNCHECKED;
                InsertMenuItem( hsubm, 2, TRUE, &menuInfo );

                menuInfo.dwTypeData = (LPSTR)"Obh()";
                menuInfo.wID = IDM_GRID_BLACK;
                menuInfo.fState = (gGrid == 1) ? MFS_CHECKED : MFS_UNCHECKED;
                InsertMenuItem( hsubm, 3, TRUE, &menuInfo );

                menuInfo.dwTypeData = (LPSTR)"Obh()";
                menuInfo.wID = IDM_GRID_WHITE;
                menuInfo.fState = (gGrid == 2) ? MFS_CHECKED : MFS_UNCHECKED;
                InsertMenuItem( hsubm, 4, TRUE, &menuInfo );

                SetMenu( hwnd, hmenu );
            }

            // EChẼ^CgύX
            setTitleStr( title, nnn );
            SetWindowText( hwnd, (LPCTSTR)title );
            break;

        case WM_FILTER_EXIT:
            mem_free();
            ReleaseCapture(); // Ô
            // INIɐݒۑ
            fp->exfunc->ini_save_int( fp, (LPSTR)"nnn",     nnn );          // {
            fp->exfunc->ini_save_int( fp, (LPSTR)"reverse", bReverse?1:0 ); // zC[]
            fp->exfunc->ini_save_int( fp, (LPSTR)"ruler",   bRuler?1:0 );   // [[\̗L
            fp->exfunc->ini_save_int( fp, (LPSTR)"grid",    gGrid?1:0 );    // Obh
            break;

        case WM_PAINT:
        case WM_FILTER_CHANGE_EDIT:
        case WM_SIZE:
            disp( fp, editp, NULL );
            break;

        case WM_FILTER_FILE_OPEN:
            if( fp->exfunc->is_filter_window_disp( fp ) )
            {
                mem_alloc( fp );
            }
            break;

        case WM_FILTER_CHANGE_WINDOW:
            // tB^ L<--> Ń
            if( fp->exfunc->is_filter_window_disp( fp ) )
            {
                mem_alloc( fp );
                return TRUE;
            }
            else
            {
                mem_free();
            }
            break;

        case WM_FILTER_FILE_CLOSE:
            mem_free();
            disp( fp, editp, NULL );
            break;

        case WM_FILTER_MAIN_MOUSE_DOWN:
            // ҏWʂŃ}EX{^
            if( !bFixFlag )
            {
                // WύX
                POINT p;
                p.x = (int)((short)LOWORD(lparam));
                p.y = (int)((short)HIWORD(lparam));
                sub_pos.x = 0;
                sub_pos.y = 0;
                // W摜ȂAEChE\XV
                if( p.x >= 0 && p.x < bmp_width && p.y >= 0 && p.y < bmp_height )
                {
                    if( bufDC ) disp( fp, editp, &p );
                    bDragFlagEdit = TRUE;
                    bDragFlagWin  = FALSE;
                }
                else
                {
                    bDragFlagWin  = FALSE;
                    bDragFlagEdit = FALSE;
                }
            }
            else
            {
                bDragFlagWin  = FALSE;;
                bDragFlagEdit = FALSE;
            }
            break;

        case WM_FILTER_MAIN_MOUSE_UP:
        case WM_FILTER_MAIN_MOVESIZE:
        case WM_FILTER_MAIN_MOUSE_DBLCLK:
            // ҏWʂł̃hbOI
            bDragFlagEdit = FALSE;
            bDragFlagWin  = FALSE;
            break;

        case WM_FILTER_MAIN_MOUSE_MOVE:
            // ҏWʂŃ}EXړ
            if( !bFixFlag && bDragFlagEdit && !bDragFlagWin )
            {
                // hbOAWύX
                POINT p;
                p.x = (int)((short)LOWORD(lparam));
                p.y = (int)((short)HIWORD(lparam));
                sub_pos.x = 0;
                sub_pos.y = 0;
                if( bufDC ) disp( fp, editp, &p );
            }
            else
            {
                bDragFlagWin  = FALSE;
                bDragFlagEdit = FALSE;
            }
            break;

        case WM_LBUTTONDOWN:
            // EChEŃ}EX{^
            if( !bFixFlag )
            {
                // hbOJn
                bDragFlagWin  = TRUE;
                bDragFlagEdit = FALSE;
                drag_pos.x = (int)((short)LOWORD(lparam));
                drag_pos.y = (int)((short)HIWORD(lparam));
                SetCursor( LoadCursor( NULL, IDC_SIZEALL ) ); // J[\ύX
                SetCapture(hwnd); // }EXLv`Jn
            }
            break;

        case WM_LBUTTONUP:
        //case WM_NCMOUSEMOVE:
            // EChEł̃hbOI
            bDragFlagWin  = FALSE;
            bDragFlagEdit = FALSE;
            ReleaseCapture(); // }EXLv`I
            break;

        case WM_ACTIVATE:
            // EChE̔ANeBuɂÔ߃hbOtONA
            if( LOWORD(wparam) == 0 )
            {
                bDragFlagWin = FALSE;
                ReleaseCapture(); // Ô
            }
            break;

        case WM_MOUSEMOVE:
            // EChEŃ}EXړ
            if( !bFixFlag && bDragFlagWin )
            {
                // hbO
                POINT p;
                p.x = (int)((short)LOWORD(lparam));
                p.y = (int)((short)HIWORD(lparam));
                sub_pos.x += p.x - drag_pos.x;
                sub_pos.y += p.y - drag_pos.y;
                drag_pos.x = p.x;
                drag_pos.y = p.y;
                if( bufDC ) disp(fp, editp, NULL);
                SetCursor( LoadCursor( NULL, IDC_SIZEALL ) ); // J[\ύX
            }
            else
            {
                bDragFlagWin  = FALSE;
                bDragFlagEdit = FALSE;
            }
            break;

        case WM_MBUTTONUP:
            // NbNꂽ̂ōWŒ
            bFixFlag = !bFixFlag;
            if( bFixFlag )
            {
                bDragFlagWin  = FALSE;
                bDragFlagEdit = FALSE;
            }
            setTitleStr( title, nnn );
            SetWindowText( hwnd, (LPCTSTR)title );
            break;

        case WM_MOUSEWHEEL:
        {
            // }EXzC[̉]
            int d = (short)HIWORD(wparam);
            if( (!bReverse && d < 0) || (bReverse && d > 0) )
            {
                if( nnn > MAG_MIN )
                {
                    // {
                    nnn--;
                    setTitleStr( title, nnn );
                    SetWindowText( hwnd, (LPCTSTR)title );
                    if( bufDC ) disp( fp, editp, NULL );
                }
                bDragFlagWin  = FALSE;
                bDragFlagEdit = FALSE;
            }
            else if( (!bReverse && d > 0) || (bReverse && d < 0) )
            {
                if( nnn < MAG_MAX )
                {
                    // {グ
                    nnn++;
                    setTitleStr( title, nnn );
                    SetWindowText( hwnd, (LPCTSTR)title );
                    if( bufDC ) disp( fp, editp, NULL );
                }
                bDragFlagWin  = FALSE;
                bDragFlagEdit = FALSE;
            }
        }
            break;

        case WM_RBUTTONUP:
            // EChEŉENbN
            if( nnn > MAG_MIN )
            {
                // {
                nnn--;
                setTitleStr( title, nnn );
                SetWindowText( hwnd, (LPCTSTR)title );
                if( bufDC ) disp( fp, editp, NULL );
            }
            bDragFlagWin  = FALSE;
            bDragFlagEdit = FALSE;
            break;

        case WM_LBUTTONDBLCLK:
            // EChEōNbN
            if( nnn < MAG_MAX )
            {
                // {グ
                nnn++;
                setTitleStr( title, nnn );
                SetWindowText( hwnd, (LPCTSTR)title );
                if( bufDC ) disp( fp, editp, NULL );
            }
            bDragFlagWin  = FALSE;
            bDragFlagEdit = FALSE;
            break;

        case WM_FILTER_COMMAND:
        case WM_COMMAND:
            // Xe[^Xo[̃R}h
            switch( LOWORD(wparam) )
            {
                case IDM_REVERSE: // zC[]
                {
                    HMENU hmenu = GetMenu( hwnd );
                    if( hmenu )
                    {
                        MENUITEMINFO menuInfo;
                        menuInfo.cbSize = sizeof(MENUITEMINFO);
                        menuInfo.fMask = MIIM_STATE;
                        bReverse = !bReverse;
                        menuInfo.fState = bReverse ? MFS_CHECKED : MFS_UNCHECKED;
                        SetMenuItemInfo( hmenu, IDM_REVERSE, FALSE, &menuInfo );
                    }
                }
                    break;

                case IDM_RULER: // [[
                {
                    HMENU hmenu = GetMenu( hwnd );
                    if( hmenu )
                    {
                        MENUITEMINFO menuInfo;
                        menuInfo.cbSize = sizeof(MENUITEMINFO);
                        menuInfo.fMask = MIIM_STATE;
                        bRuler = !bRuler;
                        menuInfo.fState = bRuler ? MFS_CHECKED : MFS_UNCHECKED;
                        SetMenuItemInfo( hmenu, IDM_RULER, FALSE, &menuInfo );
                    }
                    disp( fp, editp, NULL );
                }
                    break;

                case IDM_GRID_NONE: // ObhiȂj
                {
                    HMENU hmenu = GetMenu( hwnd );
                    if( hmenu )
                    {
                        MENUITEMINFO menuInfo;
                        menuInfo.cbSize = sizeof(MENUITEMINFO);
                        menuInfo.fMask = MIIM_STATE;
                        gGrid = 0;
                        menuInfo.fState = MFS_CHECKED;
                        SetMenuItemInfo( hmenu, IDM_GRID_NONE , FALSE , &menuInfo );
                        menuInfo.fState = MFS_UNCHECKED;
                        SetMenuItemInfo( hmenu, IDM_GRID_BLACK, FALSE , &menuInfo );
                        SetMenuItemInfo( hmenu, IDM_GRID_WHITE, FALSE , &menuInfo );
                    }
                    disp( fp, editp, NULL );
                }
                    break;

                case IDM_GRID_BLACK: // Obhij
                {
                    HMENU hmenu = GetMenu( hwnd );
                    if( hmenu )
                    {
                        MENUITEMINFO menuInfo;
                        menuInfo.cbSize = sizeof(MENUITEMINFO);
                        menuInfo.fMask = MIIM_STATE;
                        gGrid = 1;
                        menuInfo.fState = MFS_CHECKED;
                        SetMenuItemInfo( hmenu, IDM_GRID_BLACK, FALSE , &menuInfo );
                        menuInfo.fState = MFS_UNCHECKED;
                        SetMenuItemInfo( hmenu, IDM_GRID_NONE , FALSE , &menuInfo );
                        SetMenuItemInfo( hmenu, IDM_GRID_WHITE, FALSE , &menuInfo );
                    }
                    disp( fp, editp, NULL );
                }
                    break;

                case IDM_GRID_WHITE: // Obhij
                {
                    HMENU hmenu = GetMenu( hwnd );
                    if( hmenu )
                    {
                        MENUITEMINFO menuInfo;
                        menuInfo.cbSize = sizeof(MENUITEMINFO);
                        menuInfo.fMask = MIIM_STATE;
                        gGrid = 2;
                        menuInfo.fState = MFS_CHECKED;
                        SetMenuItemInfo( hmenu, IDM_GRID_WHITE, FALSE , &menuInfo );
                        menuInfo.fState = MFS_UNCHECKED;
                        SetMenuItemInfo( hmenu, IDM_GRID_NONE , FALSE , &menuInfo );
                        SetMenuItemInfo( hmenu, IDM_GRID_BLACK, FALSE , &menuInfo );
                    }
                    disp( fp, editp, NULL );
                }
                    break;
            }
            break;

    }
    return FALSE;
}

